/////////////////////////////////////////////////////////////////
//Feigenbaum-Lyapunov-Diagramm-Variante
//////////////////////////////////////////////////////////////


//Initialisierung
float rU = 0  ; 
float rO = 0;
float fU = 0; 
float fO = 0;
float lU = 0;
float lO = 0;
//Zwischenspeicher:
float  rUNeu, rONeu, fUNeu, fONeu;
//Für staflKes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, muss man mit double-Werten rechnen
float lAlt, fAlt, fNeu, d; 
int w = 800; 
int h = 800; 
int NF, LF;
int i; //Iteration Feigenbaum
float flK; // r-Koordinate für beide
float fyK; //y-Koordinaten Feigenbaum
float NullAchseF;
boolean rKoordatenGezeichnet =false;
float r; //Parameter für logistisches Wachstum
int lZ ; //Anzahl Zwischenschritte für Ly.Exp
float sL; //Lyap Summe
float lambda; //LypExp
int NL, LL;
float lNeu;
float lyK; //Koordinaten Lyapunov
float NullAchseL;
float f; //Anzahl der Schritte in Lyapanov im Vergleich zu Feigenbaum

String s; //Zur Beschriftung des Bildes

///////////////////////////////////////////////////////////////////////////

//Initialisierungen  
void setup() { 
  size(800,800);
  background(255); 
  rU = 0; 
  rO = 0.9;
  fU = -0.2; 
  fO = 4;
  lU = -5;
  lO =1.2;
  NF= 1000; //Anzahl Iterationen Feigenbaum
  LF =500; //Feigenbaum ab hier gerechnet
  r = 0.01; //Start r
  d = (rO-rU)/2000; //Schrittweite
 
 NL = 800; //Anzahl Iterationen Lyapunov
  LL = 100 ; //Lyapunov ab hier gerechnet
 lZ = 32; //Anzahl Lyapunov Zwischenschritte
}

void draw() {
  
  if (r<rO){
   
    for(int i =0; i<lZ; i++){
       iteriereL(r);
        r =r + d/lZ;
    }
    iteriereF(r);
  }
  
  
  if (!rKoordatenGezeichnet){
     stroke(0,150,0,50);//r-Achse
     strokeWeight(1);
    float deltaS = (rO-rU)/20;
    float rTempK, yTempK;
    float rTemp = rU;
    while(rTemp < rO){
      rTemp = rTemp +deltaS;
      rTempK = map(rTemp , rU, rO, 0, w); //r-Koordinate
      yTempK = map(0, fU, fO, h, 0);  // y-Koordinate
      line(rTempK,0,rTempK, h); 
      line(0,yTempK,w,yTempK );
      s=nf(rTemp,1,3);
      fill(0);
      textSize(16);
      text("r",w-20,h-60);
      textSize(12);
      text(s, rTempK-10, h - 10);
      rKoordatenGezeichnet = true; 
   }
  }
 
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  background(255);
  rKoordatenGezeichnet =false;
  rUNeu = map(mouseX, 0, w, rU, rO)-(rO-rU)/10;
  rONeu = map(mouseX, 0, w, rU, rO)+(rO-rU)/10;
  fUNeu = map(mouseY, 0, h, fO, fU)-(fO-fU)/10;
  fONeu = map(mouseY, 0, h, fO, fU)+(fO-fU)/10;
  rU = rUNeu; 
  rO = rONeu; 
  fU = fUNeu; 
  fO = fONeu;
  r = rU; 
  d = (rO-rU)/1000;
  NF = NF+100;
  LF = LF +200;
  println("mousePressed startet");
    
}
//////////////////////////////////////////////////////////
//Feigenbaum-Iteration
////////////////////////////////////////////////////////
void iteriereF(float r) {  
  stroke(0);
   strokeWeight(1);
  fAlt = 0.2;// println(fAlt,r);
  flK = map(r, rU, rO, 0, w);      
  i=0;
  while (i <=NF) {
   
    fNeu =  r*(-1.25*pow(fAlt,4)+10*pow(fAlt,3)-25.75*fAlt*fAlt+23*fAlt);
   // println(fNeu);
    if (i < LF && abs(fNeu) < 20) {
      fyK = map(fNeu, fU, fO, h, 0);   
      point(flK, fyK);    //println("F: "+flK);
    }
    fAlt = fNeu;
    i++;
  }
 
}

////////////////////////////////////////////////////////
//Lyapunov-Iteration
//////////////////////////////////////////////////////
void iteriereL(float r) {
  stroke(255,0,0);
  strokeWeight(1);
  lambda = 0;
  lAlt = 0.5;
  sL = 0;
  flK = map(r, rU, rO, 0, w);  
  i=0;
  while (i <=NL) {
    lNeu =r*(-1.25*pow(lAlt,4)+10*pow(lAlt,3)-25.75*lAlt*lAlt+23*lAlt);
    if (i > LL) {//ab hier wird der Exponent aufgebaut
      lNeu =  r*(-1.25*pow(lAlt,4)+10*pow(lAlt,3)-25.75*lAlt*lAlt+23*lAlt);
       lAlt = lNeu; 
       sL = sL + log(abs(r*(-5*pow(lAlt,3)+30*pow(lAlt,2)-51.5*lAlt +23)));//Ableitung
    }
    lAlt = lNeu;
    i++;
  }
  lambda = sL/(NL-LL); 
  if(abs(lambda) < 10){
    lyK = map(lambda,lU,lO,h,0);
    strokeWeight(1.2);
    point(flK, lyK+100);
  }
  stroke(0,0,255);
  strokeWeight(1);
  NullAchseL = map(0,lU,lO,h,0);
  point(flK, NullAchseL + 100);
}